#!/usr/bin/bash

# Some changes by ndias@lip.pt in 2014/03/13
# Adding checking ip6tables 2016-04-01 ndias@lip.pt version 0.2
# Version 0.2 - Rewrite - 2019/03/08

IPT=""

function usage {

  echo
  echo "Error Usage: $0 [-4|-6]"
  echo "-4 check if ip6tables is up"
  echo "-6 check if ip6tables is up"
  exit 0
}

while getopts "46" opt; do
 
  case $opt in
	4) IPT="/sbin/iptables";;
	6) IPT="/sbin/ip6tables";;
 	*) usage;;
  esac
done

if [ $# -ne 1 ]; then
 usage
fi

GREP='/bin/grep'
WC='/usr/bin/wc'

STAT=0
OUTPUT=''
CHAINS=$($IPT -nvL | $GREP Chain | cut -d" " -f2)
TOTAL=0

for CHAIN in $CHAINS ; do

  CNT=$($IPT -S "$CHAIN" | $WC -l)
  TOTAL=$((TOTAL+CNT-1))

done

  if [ $TOTAL -eq 0 ] ; then
 
    OUTPUT="ERROR: $(echo $IPT | cut -d"/" -f3) no Rules"
    STAT=2

  else

    OUTPUT="OK: $(echo $IPT | cut -d"/" -f3) $TOTAL rules"

  fi

echo "$OUTPUT"

exit $STAT
